//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3A54E34E0379.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3A54E34E0379.cm

//## begin module%3A54E34E0379.cp preserve=no
//## end module%3A54E34E0379.cp

//## Module: DataInputRecord%3A54E34E0379; Package specification
//## Subsystem: XSModel::Data%367691B49E40
//## Source file: /data/veris5/millerj/headas/Xspec/src/XSModel/Data/DataInputRecord.h

#ifndef DATAINPUTRECORD_H
#define DATAINPUTRECORD_H 1

//## begin module%3A54E34E0379.additionalIncludes preserve=no
//## end module%3A54E34E0379.additionalIncludes

//## begin module%3A54E34E0379.includes preserve=yes
//## end module%3A54E34E0379.includes

// xsTypes
#include "xsTypes.h"

class DataSet;
class BackCorr;
class Response;

//## begin module%3A54E34E0379.declarations preserve=no
//## end module%3A54E34E0379.declarations

//## begin module%3A54E34E0379.additionalDeclarations preserve=yes
//## end module%3A54E34E0379.additionalDeclarations


//## begin DataInputRecord%3A4902C50318.preface preserve=yes
//## end DataInputRecord%3A4902C50318.preface

//## Class: DataInputRecord%3A4902C50318
//## Category: XSModel::Data%36349D4100F3
//## Subsystem: XSModel::Data%367691B49E40
//## Persistence: Transient
//## Cardinality/Multiplicity: n



class DataInputRecord 
{
  //## begin DataInputRecord%3A4902C50318.initialDeclarations preserve=yes
  //## end DataInputRecord%3A4902C50318.initialDeclarations

  public:
    //## Constructors (generated)
      DataInputRecord(const DataInputRecord &right);

    //## Constructors (specified)
      //## Operation: DataInputRecord%3A49036D036E
      DataInputRecord (const string& fName, const IntegerArray& specNums = IntegerArray(), std::size_t groupNum = 1, const IntegerArray& specRange = IntegerArray(1,0), size_t nCommas = 0);

    //## Destructor (generated)
      ~DataInputRecord();

    //## Assignment Operation (generated)
      DataInputRecord & operator=(const DataInputRecord &right);


    //## Other Operations (specified)
      //## Operation: updateSpectrumCounts%3A54DAD2025C
      void updateSpectrumCounts (size_t numberOfSpectra);

      //## Operation: report%3A54DB390087
      void report ();

      //## Operation: fileName%3A5CAF5D0393
      const string& fileName () const;

      //## Operation: renumber%3A75D2F502F6
      void renumber (size_t newIndex);

      //## Operation: operator<%3BA60EF4021C
      friend bool operator < (const DataInputRecord& left, const DataInputRecord& right);

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: fileName%3A4902E5036A
      string& fileName ();
      void fileName (const string& value);

      //## Attribute: groupNumber%3A4903150039
      size_t groupNumber () const;
      void groupNumber (size_t value);

      //## Attribute: numTrailCommas%3EB2D4830292
      size_t numTrailCommas () const;
      void numTrailCommas (size_t value);

    //## Get and Set Operations for Associations (generated)

      //## Association: XSModel::Data::<unnamed>%3E48158700B8
      //## Role: DataInputRecord::spectrumNumber%3E481587031E
      //## Qualifier: index%3E4815B20027; int
      const IntegerArray& spectrumNumber () const;
      void setSpectrumNumber (const IntegerArray& value);
      int spectrumNumber (int index) const;
      void spectrumNumber (int index, int value);

      //## Association: XSModel::Data::<unnamed>%3E4815D60194
      //## Role: DataInputRecord::spectrumRange%3E4815D70056
      //## Qualifier: index%3E4815E60216; int
      const IntegerArray& spectrumRange () const;
      void setSpectrumRange (const IntegerArray& value);
      int spectrumRange (int index) const;
      void spectrumRange (int index, int value);

      //## Association: XSModel::Data::<unnamed>%3EB2DF6200F0
      //## Role: DataInputRecord::response%3EB2DF630366
      const Response* response () const;
      void response (Response* value);

      //## Association: XSModel::Data::<unnamed>%3EB2E04201B1
      //## Role: DataInputRecord::backcorr%3EB2E044025B
      const BackCorr* backcorr () const;
      void backcorr (BackCorr* value);

      //## Association: XSModel::Data::<unnamed>%3EB2E0A8015D
      //## Role: DataInputRecord::data%3EB2E0A90277
      DataSet* data () const;
      void data (DataSet* value);

    // Additional Public Declarations
      //## begin DataInputRecord%3A4902C50318.public preserve=yes
      //## end DataInputRecord%3A4902C50318.public

  protected:
    // Additional Protected Declarations
      //## begin DataInputRecord%3A4902C50318.protected preserve=yes
      //## end DataInputRecord%3A4902C50318.protected

  private:

    //## Other Operations (specified)
      //## Operation: correctSpectraRows%403BB41E006A
      void correctSpectraRows (size_t numberOfSpectra);

    // Additional Private Declarations
      //## begin DataInputRecord%3A4902C50318.private preserve=yes
      //## end DataInputRecord%3A4902C50318.private

  private: //## implementation

    //## Other Operations (specified)
      //## Operation: swap%3A65ACB4026B
      void swap (DataInputRecord& right);

    // Data Members for Class Attributes

      //## begin DataInputRecord::fileName%3A4902E5036A.attr preserve=no  public: string {U} fName
      string m_fileName;
      //## end DataInputRecord::fileName%3A4902E5036A.attr

      //## begin DataInputRecord::groupNumber%3A4903150039.attr preserve=no  public: size_t {U} groupNum
      size_t m_groupNumber;
      //## end DataInputRecord::groupNumber%3A4903150039.attr

      //## begin DataInputRecord::numTrailCommas%3EB2D4830292.attr preserve=no  public: size_t {U} 
      size_t m_numTrailCommas;
      //## end DataInputRecord::numTrailCommas%3EB2D4830292.attr

    // Data Members for Associations

      //## Association: XSModel::Data::<unnamed>%3E48158700B8
      //## begin DataInputRecord::spectrumNumber%3E481587031E.role preserve=no  public: IntegerArray { -> 1VHgN}
      IntegerArray m_spectrumNumber;
      //## end DataInputRecord::spectrumNumber%3E481587031E.role

      //## Association: XSModel::Data::<unnamed>%3E4815D60194
      //## begin DataInputRecord::spectrumRange%3E4815D70056.role preserve=no  public: IntegerArray { -> 1VHgN}
      IntegerArray m_spectrumRange;
      //## end DataInputRecord::spectrumRange%3E4815D70056.role

      //## Association: XSModel::Data::<unnamed>%3EB2DF6200F0
      //## begin DataInputRecord::response%3EB2DF630366.role preserve=no  public: Response { -> 1RFHgN}
      Response* m_response;
      //## end DataInputRecord::response%3EB2DF630366.role

      //## Association: XSModel::Data::<unnamed>%3EB2E04201B1
      //## begin DataInputRecord::backcorr%3EB2E044025B.role preserve=no  public: BackCorr { -> 1RFHgN}
      BackCorr* m_backcorr;
      //## end DataInputRecord::backcorr%3EB2E044025B.role

      //## Association: XSModel::Data::<unnamed>%3EB2E0A8015D
      //## begin DataInputRecord::data%3EB2E0A90277.role preserve=no  public: DataSet { -> 1RFHgN}
      DataSet* m_data;
      //## end DataInputRecord::data%3EB2E0A90277.role

    // Additional Implementation Declarations
      //## begin DataInputRecord%3A4902C50318.implementation preserve=yes
      //## end DataInputRecord%3A4902C50318.implementation

};

//## begin DataInputRecord%3A4902C50318.postscript preserve=yes
//## end DataInputRecord%3A4902C50318.postscript

// Class DataInputRecord 

//## Get and Set Operations for Class Attributes (inline)

inline string& DataInputRecord::fileName ()
{
  //## begin DataInputRecord::fileName%3A4902E5036A.get preserve=no
  return m_fileName;
  //## end DataInputRecord::fileName%3A4902E5036A.get
}

inline void DataInputRecord::fileName (const string& value)
{
  //## begin DataInputRecord::fileName%3A4902E5036A.set preserve=no
  m_fileName = value;
  //## end DataInputRecord::fileName%3A4902E5036A.set
}

inline size_t DataInputRecord::groupNumber () const
{
  //## begin DataInputRecord::groupNumber%3A4903150039.get preserve=no
  return m_groupNumber;
  //## end DataInputRecord::groupNumber%3A4903150039.get
}

inline void DataInputRecord::groupNumber (size_t value)
{
  //## begin DataInputRecord::groupNumber%3A4903150039.set preserve=no
  m_groupNumber = value;
  //## end DataInputRecord::groupNumber%3A4903150039.set
}

inline size_t DataInputRecord::numTrailCommas () const
{
  //## begin DataInputRecord::numTrailCommas%3EB2D4830292.get preserve=no
  return m_numTrailCommas;
  //## end DataInputRecord::numTrailCommas%3EB2D4830292.get
}

inline void DataInputRecord::numTrailCommas (size_t value)
{
  //## begin DataInputRecord::numTrailCommas%3EB2D4830292.set preserve=no
  m_numTrailCommas = value;
  //## end DataInputRecord::numTrailCommas%3EB2D4830292.set
}

//## Get and Set Operations for Associations (inline)

inline const IntegerArray& DataInputRecord::spectrumNumber () const
{
  //## begin DataInputRecord::spectrumNumber%3E481587031E.get preserve=no
  return m_spectrumNumber;
  //## end DataInputRecord::spectrumNumber%3E481587031E.get
}

inline void DataInputRecord::setSpectrumNumber (const IntegerArray& value)
{
  //## begin DataInputRecord::setSpectrumNumber%3E481587031E.set preserve=no
  m_spectrumNumber = value;
  //## end DataInputRecord::setSpectrumNumber%3E481587031E.set
}

inline int DataInputRecord::spectrumNumber (int index) const
{
  //## begin DataInputRecord::spectrumNumber%3E481587031E.qualget preserve=no
  return m_spectrumNumber[index];
  //## end DataInputRecord::spectrumNumber%3E481587031E.qualget
}

inline void DataInputRecord::spectrumNumber (int index, int value)
{
  //## begin DataInputRecord::spectrumNumber%3E481587031E.qualset preserve=no
  m_spectrumNumber[index] = value;
  //## end DataInputRecord::spectrumNumber%3E481587031E.qualset
}

inline const IntegerArray& DataInputRecord::spectrumRange () const
{
  //## begin DataInputRecord::spectrumRange%3E4815D70056.get preserve=no
  return m_spectrumRange;
  //## end DataInputRecord::spectrumRange%3E4815D70056.get
}

inline void DataInputRecord::setSpectrumRange (const IntegerArray& value)
{
  //## begin DataInputRecord::setSpectrumRange%3E4815D70056.set preserve=no
  m_spectrumRange = value;
  //## end DataInputRecord::setSpectrumRange%3E4815D70056.set
}

inline int DataInputRecord::spectrumRange (int index) const
{
  //## begin DataInputRecord::spectrumRange%3E4815D70056.qualget preserve=no
  return m_spectrumRange[index];
  //## end DataInputRecord::spectrumRange%3E4815D70056.qualget
}

inline void DataInputRecord::spectrumRange (int index, int value)
{
  //## begin DataInputRecord::spectrumRange%3E4815D70056.qualset preserve=no
  m_spectrumRange[index] = value;
  //## end DataInputRecord::spectrumRange%3E4815D70056.qualset
}

inline const Response* DataInputRecord::response () const
{
  //## begin DataInputRecord::response%3EB2DF630366.get preserve=no
  return m_response;
  //## end DataInputRecord::response%3EB2DF630366.get
}

inline void DataInputRecord::response (Response* value)
{
  //## begin DataInputRecord::response%3EB2DF630366.set preserve=no
  m_response = value;
  //## end DataInputRecord::response%3EB2DF630366.set
}

inline const BackCorr* DataInputRecord::backcorr () const
{
  //## begin DataInputRecord::backcorr%3EB2E044025B.get preserve=no
  return m_backcorr;
  //## end DataInputRecord::backcorr%3EB2E044025B.get
}

inline void DataInputRecord::backcorr (BackCorr* value)
{
  //## begin DataInputRecord::backcorr%3EB2E044025B.set preserve=no
  m_backcorr = value;
  //## end DataInputRecord::backcorr%3EB2E044025B.set
}

inline DataSet* DataInputRecord::data () const
{
  //## begin DataInputRecord::data%3EB2E0A90277.get preserve=no
  return m_data;
  //## end DataInputRecord::data%3EB2E0A90277.get
}

inline void DataInputRecord::data (DataSet* value)
{
  //## begin DataInputRecord::data%3EB2E0A90277.set preserve=no
  m_data = value;
  //## end DataInputRecord::data%3EB2E0A90277.set
}

//## begin module%3A54E34E0379.epilog preserve=yes
//## end module%3A54E34E0379.epilog


#endif
